﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices; // for GetLastError()

using AIOETHW; // the namespace exposes the AIOETH Class interface 

// You must also add a reference to the AIOETHHWNet.dll in the project settings


namespace Sample1
{
    public partial class Form1 : Form
    {
        public UIntPtr uClientRef;
        public Boolean bConnected = false;
        public int pDataBytes = 6;
        public Byte[] pData = new byte[] { 0, 0, 0, 0, 0, 0 };
        public Byte[] buffer = new byte[30] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0 };
        public UInt32 Status;

        public UInt32 numPins = 48;
        public UInt32 numPorts = 6;

        // Array of controls for GUI updates:
        public CheckBox[] checkStateArray = new CheckBox[48];
        public Button[] toggleBtnArray = new Button[6];

        // For bitmasks:
        byte[] OutMask = new byte[] { 0, 0 };

        // State flags:
        public bool[] bModeOut = new bool[6];
        
        public Form1()
        {
            InitializeComponent();
            int i = 0;

            // Array of the toggle mode buttons:
            toggleBtnArray[0] = btnToggle0;
            toggleBtnArray[1] = btnToggle1;
            toggleBtnArray[2] = btnToggle2;
            toggleBtnArray[3] = btnToggle3;
            toggleBtnArray[4] = btnToggle4;
            toggleBtnArray[5] = btnToggle5;

            // Array of the LED style checkboxes:
            checkStateArray[0] = checkBoxA0_1;
            checkStateArray[1] = checkBoxA0_2;
            checkStateArray[2] = checkBoxA0_3;
            checkStateArray[3] = checkBoxA0_4;
            checkStateArray[4] = checkBoxA0_5;
            checkStateArray[5] = checkBoxA0_6;
            checkStateArray[6] = checkBoxA0_7;
            checkStateArray[7] = checkBoxA0_8;
            checkStateArray[8] = checkBoxB0_9;
            checkStateArray[9] = checkBoxB0_10;
            checkStateArray[10] = checkBoxB0_11;
            checkStateArray[11] = checkBoxB0_12;
            checkStateArray[12] = checkBoxB0_13;
            checkStateArray[13] = checkBoxB0_14;
            checkStateArray[14] = checkBoxB0_15;
            checkStateArray[15] = checkBoxB0_16;
            checkStateArray[16] = checkBoxC0_17;
            checkStateArray[17] = checkBoxC0_18;
            checkStateArray[18] = checkBoxC0_19;
            checkStateArray[19] = checkBoxC0_20;
            checkStateArray[20] = checkBoxC0_21;
            checkStateArray[21] = checkBoxC0_22;
            checkStateArray[22] = checkBoxC0_23;
            checkStateArray[23] = checkBoxC0_24;

            checkStateArray[24] = checkBoxA1_25;
            checkStateArray[25] = checkBoxA1_26;
            checkStateArray[26] = checkBoxA1_27;
            checkStateArray[27] = checkBoxA1_28;
            checkStateArray[28] = checkBoxA1_29;
            checkStateArray[29] = checkBoxA1_30;
            checkStateArray[30] = checkBoxA1_31;
            checkStateArray[31] = checkBoxA1_32;
            checkStateArray[32] = checkBoxB1_33;
            checkStateArray[33] = checkBoxB1_34;
            checkStateArray[34] = checkBoxB1_35;
            checkStateArray[35] = checkBoxB1_36;
            checkStateArray[36] = checkBoxB1_37;
            checkStateArray[37] = checkBoxB1_38;
            checkStateArray[38] = checkBoxB1_39;
            checkStateArray[39] = checkBoxB1_40;
            checkStateArray[40] = checkBoxC1_41;
            checkStateArray[41] = checkBoxC1_42;
            checkStateArray[42] = checkBoxC1_43;
            checkStateArray[43] = checkBoxC1_44;
            checkStateArray[44] = checkBoxC1_45;
            checkStateArray[45] = checkBoxC1_46;
            checkStateArray[46] = checkBoxC1_47;
            checkStateArray[47] = checkBoxC1_48;
        }
        
        private void Form1_Load(object sender, EventArgs e)
        {
            // Called before Form is displayed Initialize resources:
        }
        
        private void TimerEventProcessor(Object myObject, EventArgs myEventArgs)
        {
        }
        
        private void UpdateGUIState()
        {           
            // Get data from board update display states:
            UInt32 Status;

            Status = AEWNet.AEW_DIO_ReadAll(uClientRef, ref pDataBytes, pData); 

            // Test each bit and set check state:
            for (int i = 0; i < numPins; i++)
            {
                if ((pData[i / 8] & (1 << (i % 8))) != 0)   // looks complicated but efficient
                    checkStateArray[i].Checked = true;      // High Level
                else
                    checkStateArray[i].Checked = false;     // Low Level
            }
        }
 
        private void btnToggle_Click(object sender, EventArgs e)
        {
            // Button Clicks to toggle the input output mode and display states:

            // We are assuming we started in intput mode:
            
            Int32 i;
            Int32 iOutMask = 0x0000;
            Int16 isOutMask = 0x0000;
            int numBytes = 6;

            //Get button sender Tag (index)
            UInt32 iTagindex = 0;
            Button btnSender = sender as Button;
            if (btnSender != null)
            {
                iTagindex = Convert.ToUInt32(btnSender.Tag);
            }

            // Toggle local mode value and button display states:
            if (bModeOut[iTagindex])
            {
                bModeOut[iTagindex] = false;
                btnSender.Text = "(Output) Press for Input Mode";
            }
            else
            {
                bModeOut[iTagindex] = true;
                btnSender.Text = "(Input) Press for Output Mode";
            }

        }

        private void checkBox_Click(object sender, EventArgs e)
        {
            UInt32 iTagindex = 0;
            Int32 iOutMask = 0x0000;
            Int32 i;
            Byte bByte = 1;
            
            // Get correct checkbox and toggle the bit state:

            // Get sender Tag (index) and if check
            CheckBox chkSender = sender as CheckBox;
            iTagindex = Convert.ToUInt32(chkSender.Tag);

            i = (Int32)iTagindex;  // downcast
            int mask = 1 << (i % 8);
            iOutMask = ((pData[i / 8]) & mask); // get single bit
            if (iOutMask != 0)
                pData[i/8] = (byte)(pData[i/8] | mask);
            else 
                pData[i/8] = (byte)(pData[i/8] & ~mask);
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            Int32 Index = 0;

            String strIP;

            // Test: Hard coded option:
            //strIP = "10.1.1.251"; 

            strIP = textBoxHostIP.Text + Char.MinValue; // Add null terminator.
            Char[] charIP = new Char[32];
            charIP = strIP.ToCharArray();

            labelStatus.Text = "Attempting to Connect...";
            Application.DoEvents();
            uClientRef = AEWNet.AEW_Connect(charIP, Index);

           
            // Test pointer then last error:
            if (uClientRef == UIntPtr.Zero) // null 
            {
                int lastError = Marshal.GetLastWin32Error();  // 32 bit specific !!!
                labelStatus.Text = "Error " + lastError.ToString() + " on AEW_Connect()";
            }
            else
            {                
                Int32 numBytes = 14;
                AEWNet.AEW_DEF_GetIOConfig(uClientRef, ref numBytes, buffer);

                pData[0] = buffer[8];
                pData[1] = buffer[9];
                pData[2] = buffer[10];
                pData[3] = buffer[11];
                pData[4] = buffer[12];
                pData[5] = buffer[13];
                // Test each bit and set check state:
                for (int i = 0; i < numPins; i++)
                {
                    if ((pData[i / 8] & (1 << (i % 8))) != 0)   // looks complicated but efficient
                        checkStateArray[i].Checked = true;      // High Level
                    else
                        checkStateArray[i].Checked = false;     // Low Level
                }
                for (int i = 0; i<6; i++)
                    if ((buffer[7] & (1<<i)) == 0)
                        {
                            bModeOut[i] = false;
                            toggleBtnArray[i].Text = "(Output) Press for Input Mode";
                        }
                        else
                        {
                            bModeOut[i] = true;
                            toggleBtnArray[i].Text = "(Input) Press for Output Mode";
                        }
                Refresh();
                labelStatus.Text = "Connected.";
                btnDisconnect.Visible = true;
                btnConnect.Visible = false;
                bConnected = true;
            }

        }

        private void btnDisconnect_Click(object sender, EventArgs e)
        {           
            UInt32 Status;

            labelStatus.Text = "Disonnecting...";
            Application.DoEvents(); 
            Status = AEWNet.AEW_Disconnect(uClientRef);
            labelStatus.Text = "Disonnected!";
            bConnected = false;
            btnConnect.Visible = true;
            btnDisconnect.Visible= false;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            UInt32 Status;
            Status = AEWNet.AEW_Disconnect(uClientRef);
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void ConfigureButton_Click(object sender, EventArgs e)
        {
            int i;
            int iOutMask=0;
            byte[] buffer = new byte[7];

            // Recreate new Outmask for Configure:            
            for (i = 0; i < numPorts; i++)
            {
                if (bModeOut[i] == true)  // if output mode
                {
                    // USB-DIO96 its 12 bits in one Int16 or short  48 is 6 ports
                    iOutMask = iOutMask | (1 << i); // Int32 
                }
            }
            buffer[0] = (byte)(iOutMask & 0xFF);

            for (i = 0; i < numPins; i++)
            {
                if (checkStateArray[i].Checked == true)
                    pData[i / 8] |= (byte)(1 << (i % 8)); 
                else
                    pData[i / 8] &= (byte)~(1 << (i % 8));
            }
            buffer[1] = pData[0];
            buffer[2] = pData[1];
            buffer[3] = pData[2];
            buffer[4] = pData[3];
            buffer[5] = pData[4];
            buffer[6] = pData[5];
            int buflen = 7;
            textBox1.Text += "\r\n";
            for (i = 0; i < buflen; i++)
            {
                textBox1.Text += $"{buffer[i]:X2} ";
            }
            textBox1.Text += "\r\n";

            var status = AEWNet.AEW_DEF_Configure(uClientRef, ref buflen, buffer);
            textBox1.Text += $"\r\nAEW_DEF_Configure() status = {status}\r\n";
        }
    }
}
